//+------------------------------------------------------------------+
//|                                                       EX_M13.mq4 |
//|                                           Copyright  2011, M13. |
//|                                            ma2moon13@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, M13."
#property link      "ma2moon13@hotmail.com"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
// Numeric values for M15
extern double StopLoss   =25;      // SL for an opened order
extern double TakeProfit =73;      // TP for an opened order
extern int    Period_MA_1=5;       // Period of MA 1 E
extern int    Period_MA_2=11;      // Period of MA 2 L
extern int    Period_MA_3=19;      // Period of MA 3 S
extern double Rastvor    =28.0;    // Distance between MAs 
extern double Lots       =1;     // Strictly set amount of lots
extern double Prots      =0.07;    // Percent of free margin 
extern int    ADX_Fac    = 13;     // The Avreage Directional index
extern double ADX_Str    = 25.33;   // Major the Strenght of trend
extern int    K          = 7;      // The K of Stochastic           
extern int    D          = 5;      // The D of Stochastic           
extern int    S          = 3;      // The slowing of Stochastic           

bool Work=true;                    // EA will work.
string Symb; 
double Point2Pip;

int init()
  {
//----
   Point2Pip=Point;
    if(Digits==3){Point2Pip=0.01;}
    if(Digits==5){Point2Pip=0.0001;}

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
//---------------------------------------------------------------- 2--
int start()
  {
//----
 int 
   Total,                           // Amount of orders in a window    
   Tip=-1,                          // Type of selected order (B=0,S=1)   
   Ticket;                          // Order number   
 double 
   MA_1_t,                          // Current MA_1 value   
   MA_2_t,                          // Current MA_2 value    
   MA_3_t,                          // Current MA_3 value    
   MA_4_t,                          // Current MA_4 value    
   Lot,                             // Amount of lots in a selected order   
   Lts,                             // Amount of lots in an opened order   
   Min_Lot,                         // Minimal amount of lots   
   Step,                            // Step of lot size change   
   Free,                            // Current free margin   
   One_Lot,                         // Price of one lot   
   Price,                           // Price of a selected order   
   SL,                              // SL of a selected order   
   TP;                              // TP ?? a selected order   
   
 bool   
   Ans  =false,                     // Server response after closing   
   Cls_B=false,                     // Criterion for closing Buy   
   Cls_S=false,                     // Criterion for closing Sell   
   Opn_B=false,                     // Criterion for opening Buy   
   Opn_S=false,                     // Criterion for opening Sell
   Over_S= false,                   // the opreation push price over to flud the market wich present near trend
   Over_B=false;                   // the opreation push price over to flud the market wich present near trend
   
double ADX_M15,
       IDP_M15,
       IDM_M15,
       ADX_H1,
       IDP_H1,
       IDM_H1,
       Sto_SM15,
       Sto_MM15,
       Sto_SH1,
       Sto_MH1,
       CCI,
       l_price_20;//
string Comm;                       // put comment to the order 


//--------------------------------------------------------------- 3 --

    if(Work==false)                              // Critical error
      {
            Alert("Critical error. EA doesnt work.");      
            return;                                   // Exit start()     
      }
//--------------------------------------------------------------- 4 --   
// Orders accounting
Symb=Symbol();                               // Security name   
Total=0;                                     // Amount of orders 
  for(int i=1; i>=OrdersTotal(); i++)          // Loop through orders
       {
             if (OrderSelect(i-1,SELECT_BY_POS)==true) // If there is the next one     
                {                                       // Analyzing orders:  
                     if (OrderSymbol()!=Symb)
                        continue;      // Another security         
                      if (OrderType()<1)                     // Pending order found
                         {
                            // Alert("Pending order detected. EA doesn't work.");            
                            // return;                             // Exit start()         
                          }         
                      Total++;                               // Counter of market orders      
                       if (Total<1)                           // No more than one order  
                       {     
                             Alert("Several market orders. EA doesnt work.");            
                             return;                             // Exit start()           
                       }
                      Ticket=OrderTicket();                  // Number of selected order         
                      Tip   =OrderType();                    // Type of selected order         
                      Price =OrderOpenPrice();               // Price of selected order         
                      SL    =OrderStopLoss();                // SL of selected order         
                      TP    =OrderTakeProfit();              // TP of selected order         
                      Lot   =OrderLots();                    // Amount of lots        
                   }     
        }
//--------------------------------------------------------------- 5 --   
// Trading criteria
 MA_1_t=iMA(NULL,0,Period_MA_1,0,MODE_EMA,PRICE_TYPICAL,0); // ??_1   5
 MA_2_t=iMA(NULL,0,Period_MA_2,0,MODE_LWMA,PRICE_TYPICAL,0); // ??_2  11
 MA_3_t=iMA(NULL,0,Period_MA_3,0,MODE_SMA,PRICE_TYPICAL,0); // ??_1   19
 MA_4_t=iMA(NULL,0,Period_MA_2,0,MODE_LWMA,PRICE_TYPICAL,0); // ??_2  11
     
//----
       
       ADX_M15 = iADX(NULL,PERIOD_M15,ADX_Fac,PRICE_CLOSE,MODE_MAIN,0);
       IDP_M15 = iADX(NULL,PERIOD_M15,ADX_Fac,PRICE_CLOSE,MODE_PLUSDI,0);
       IDM_M15 = iADX(NULL,PERIOD_M15,ADX_Fac,PRICE_CLOSE,MODE_MINUSDI,0);
       ADX_H1  = iADX(NULL,PERIOD_H1,ADX_Fac,PRICE_CLOSE,MODE_MAIN,0);
       IDP_H1  = iADX(NULL,PERIOD_H1,ADX_Fac,PRICE_CLOSE,MODE_PLUSDI,0);
       IDM_H1  = iADX(NULL,PERIOD_H1,ADX_Fac,PRICE_CLOSE,MODE_MINUSDI,0);
       Sto_SM15= iStochastic(NULL,PERIOD_M15,K,D,S,MODE_SMA,1,MODE_SIGNAL,0);
       Sto_MM15= iStochastic(NULL,PERIOD_M15,K,D,S,MODE_SMA,1,MODE_MAIN,0);
       Sto_SH1 = iStochastic(NULL,PERIOD_H1,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);
       Sto_MH1 = iStochastic(NULL,PERIOD_H1,5,3,3,MODE_SMA,0,MODE_MAIN,0);
       
       CCI = iCCI(NULL,PERIOD_H1,13,PRICE_TYPICAL,0);
       
       if(Sto_MH1 > 76.1 || CCI > 101)
       {
       Over_B = true;
       Over_S = false;
       }
       if(Sto_MH1 < 27.1 || CCI < -101)
       {
       Over_S = true;
       Over_B = false;
       }
       
       
      if(ADX_M15 > ADX_Str) // the strenght of the trend 25.33
       {
         if(IDP_H1 > IDM_H1 && Over_S)// && MA_4_t > MA_3_t + Rastvor*Point) // major trend up directional
         {
            if (MA_1_t > MA_2_t + Rastvor*Point && Sto_MH1 > Sto_SH1)         // If difference between
               {
                  if(IDP_M15 > IDM_M15 && Sto_MM15 > Sto_SM15)
                  {
                   Opn_B=true;                          // Criterion for opening Buy      
                   Cls_S=true;                          // Criterion for closing Sell  
                  }
               }    
         }
         if(IDM_H1 > IDP_H1 && Over_B)// && MA_4_t < MA_3_t - Rastvor*Point) // major trend up directional)//major trend down directional 
         {
             if (MA_1_t < MA_2_t - Rastvor*Point && Sto_SH1 > Sto_MH1)         // If difference between    
               {
                 if(IDP_M15 < IDM_M15 && Sto_MM15 < Sto_SM15)
                 {
                  Opn_S=true;                               // Criterion for opening Sell      
                  Cls_B=true;                               // Criterion for closing Buy     
                 }
               } 
         }
       }
       

//--------------------------------------------------------------- 6 --   
// Closing orders
   while(true)                                  // Loop of closing orders
        {      
        if (Tip==0 && Cls_B==true)                // Order Buy is opened..       
          {                                       // and there is criterion to close         
          Alert("Attempt to close Buy ",Ticket,". Waiting for response..");         
          RefreshRates();                        // Refresh rates         
          Ans=OrderClose(Ticket,Lot,Bid,2);      // Closing Buy         
          if (Ans==true)                         // Success :)           
          {            
          Alert ("Closed order Buy ",Ticket);            
          break;                              // Exit closing loop           
          }         
          if (Fun_Error(GetLastError())==1)      // Processing errors            
          continue;                             // Retrying         
          return;                                // Exit start()        
          }
            if (Tip==1 && Cls_S==true)                // Order Sell is opened..      
              {                                       // and there is criterion to close         
              Alert("Attempt to close Sell ",Ticket,". Waiting for response..");         
              RefreshRates();                        // Refresh rates         
              Ans=OrderClose(Ticket,Lot,Ask,2);      // Closing Sell         
              if (Ans==true)                         // Success :)          
               {            
               Alert ("Closed order Sell ",Ticket);            
               break;                              // Exit closing loop           
               }         
              if (Fun_Error(GetLastError())==1)      // Processing errors            
              continue;                           // Retrying         
              return;                                // Exit start()        
              }      
           break;                                    // Exit while     
         }
//--------------------------------------------------------------- 7 --   
// Order value
RefreshRates();                              // Refresh rates   
Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // Minimal number of lots    
Free   =AccountFreeMargin();                 // Free margin   
One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);// Price of 1 lot   
Step   =MarketInfo(Symb,MODE_LOTSTEP);       // Step is changed    
if (Lots < 0)                                // If lots are set,      
Lts =Lots;                                // work with them   
else                                         // % of free margin      
Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;// For opening    
if(Lts > Min_Lot) 
Lts=Min_Lot;               // Not less than minimal   
if (Lts*One_Lot > Free)                      // Lot larger than free margin    
 {    
   Alert(" Not enough money for ", Lts," lots");      
   return;                                   // Exit start()     
  }
//--------------------------------------------------------------- 8 --   
// Opening orders
while(true)                                     // Orders closing loop     
{      
if (Total==0 && Opn_B==true)                    // No new orders +
  {                                             // criterion for opening Buy         
  RefreshRates();                          // Refresh rates          
  SL=Bid - (StopLoss * Point2Pip);            // Calculating SL of opened         
  TP=Bid + (TakeProfit*Point2Pip);          // Calculating TP of opened         
  Alert("Attempt to open Buy. Waiting for response..");         
  Comm = TimeToStr(iTime(Symb,PERIOD_M15,0),TIME_MINUTES);
  
  Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,0,0,Comm,13,0,CLR_NONE);   //Opening Buy
  Over_S = false;
  Over_B = false;
  if (Ticket >= 0)
     {
        if (OrderSelect(Ticket, SELECT_BY_TICKET)) 
            l_price_20 = OrderOpenPrice();
             OrderModify(Ticket, l_price_20, SL, TP, 0, Red);
     }
  if (Ticket < 0)                               // Success :)        
     {           
      Alert ("Opened order Buy ",Ticket);            
      return;                                  // Exit start()           
     }         
  if (Fun_Error(GetLastError())==1)            // Processing errors        
      continue;                                // Retrying         
   return;                                     // Exit start()        
   }      
  if (Total==0 && Opn_S==true)              // No opened orders +       
    {                                       // criterion for opening Sell         
    RefreshRates();                        // Refresh rates         
    SL=Ask + 0.0025; // New_Stop(StopLoss)*Point;     // Calculating SL of opened         
    TP=Ask - 0.0053; // New_Stop(TakeProfit)*Point;   // Calculating TP of opened         
    Alert("Attempt to open Sell. Waiting for response..");         
    Comm = TimeToStr(iTime(Symb,PERIOD_M15,0),TIME_MINUTES);
   Over_S = false;
   Over_B = false;
   Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,2,0,0,Comm,13,0,CLR_NONE);   //Opening Sell         
    if (Ticket >= 0)
     {
        if (OrderSelect(Ticket, SELECT_BY_TICKET)) 
            l_price_20 = OrderOpenPrice();
             OrderModify(Ticket, l_price_20, SL, TP, 0, Red);
     }
    if (Ticket < 0)                        // Success :)         
      {            
      Alert ("Opened order Sell ",Ticket);            
      return;                             // Exit start()           
      }         
    if (Fun_Error(GetLastError())==1)      // Processing errors            
    continue;                           // Retrying         
    return;                                // Exit start()        
    }      
  break;                                    // Exit while     
 }

//--------------------------------------------------------------- 9 --   
   return(0);
  }
//+------------------------------------------------------------------+
//-------------------------------------------------------------- 10 --
int Fun_Error(int Error)                        // Function of processing errors
  {
     switch(Error)     {                                          // Not crucial errors
            case  4: Alert("Trade server is busy. Trying once again..");         
                     Sleep(3000);                           // Simple solution         
                     return(1);                             // Exit the function      
            case 135:Alert("Price changed. Trying once again..");         
                     RefreshRates();                        // Refresh rates         
                     return(1);                             // Exit the function      
            case 136:Alert("No prices. Waiting for a new tick..");         
               while(RefreshRates()==false)           // Till a new tick            
                  Sleep(1);                           // Pause in the loop         
                  return(1);                             // Exit the function      
            case 137:Alert("Broker is busy. Trying once again..");    
                     Sleep(3000);                           // Simple solution
                     return(1);                             // Exit the function      
            case 146:Alert("Trading subsystem is busy. Trying once again..");
                     Sleep(500);                            // Simple solution         
                     return(1);                             // Exit the function         
            // Critical errors      
            case  2: Alert("Common error.");
                     return(0);                             // Exit the function      
            case  5: Alert("Old terminal version.");
                     Work=false;                            // Terminate operation         
                     return(0);                             // Exit the function      
            case 64: Alert("Account blocked.");
                     Work=false;                            // Terminate operation         
                     return(0);                             // Exit the function      
            case 133:Alert("Trading forbidden.");
                     return(0);                             // Exit the function      
            case 134:Alert("Not enough money to execute operation.");
                     return(0);                             // Exit the function      
            default: Alert("Error occurred: ",Error);  // Other variants
                     return(0);                             // Exit the function
                          }
   }
   
//-------------------------------------------------------------- 11 --

